<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	
<script language="JavaScript">

var debug = false;
var currentStep = 1;
var pnrIsValid = false;
var pnrIsAcceptable = false;
var caseIsValid = false;
var samplingDateIsValid = true;
var freezerDateIsValid = true;

var patientInfo = null;
var bloodInfo = null;
var consentInfo = null;

function init()
{
	var frm = document.forms['reggie'];
	frm.caseName.focus();
}

function step1IsValid()
{
	return pnrIsValid && caseIsValid;
}

function step1IsAcceptable()
{
	return pnrIsAcceptable && caseIsValid;
}

function step2IsValid()
{
	var formOk = true;
	var frm = document.forms['reggie'];

	// New patient only
	if (!patientInfo.id)
	{
		// Validate 'New patient' form
		if (frm.allFirstNames.value == '')
		{
			setInputStatus('allFirstNames', 'Missing', 'invalid');
			frm.allFirstNames.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('allFirstNames', '', 'valid');
		}
		
		if (frm.familyName.value == '')
		{
			setInputStatus('familyName', 'Missing', 'invalid');
			frm.familyName.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('familyName', '', 'valid');
		}

		if (frm.patientCode.value == '')
		{
			setInputStatus('patientCode', 'Missing', 'invalid');
			frm.patientCode.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('patientCode', '', 'valid');
		}	
	}
	return formOk;
}

function step3IsValid()
{
	var isValid = samplingDateIsValid && freezerDateIsValid;
	return isValid;
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	var frm = document.forms['reggie'];
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid())
		{
			gotoStep2();
		}
		else if (step1IsAcceptable())
		{
			if (manual)
			{
				gotoStep2();
			}
			else
			{
				frm.personalNumber.focus();
				setInnerHTML('gonext.message', 'Personal number is non-standard. Click \'Next\' to continue registration.');
			}
		}
	}
	else if (currentStep == 2)
	{
		if (step2IsValid()) gotoStep3();
	}
}

function caseNameOnChange()
{
	var frm = document.forms['reggie'];
	var caseName = frm.caseName.value.toUpperCase();
	caseIsValid = false;
	if (caseName == '')
	{
		setInputStatus('case', 'Missing', 'invalid');
		frm.caseName.focus();
		return;
	}
	if (!isValidCaseName(caseName, true)) // Allow 'C' suffix to be used
	{
		setInputStatus('case', 'Only 7-digits name + optional \'C\' is allowed.', 'invalid');
		frm.caseName.focus();
		return;
	}

	frm.caseName.value = caseName;
	setInputStatus('case', '', 'valid');
	caseIsValid = true;
	
	getBloodInfo();
}

function personalNumberOnChange()
{
	var frm = document.forms['reggie'];
	var pnr = frm.personalNumber.value;
	pnrIsValid = false;
	pnrIsAcceptable = true;
	
	var pnrLen = pnr.length;
	if (pnrLen != 12 && pnrLen != 10)
	{
		setInputStatus('pnr', pnrLen < 12 ? 'Too short' : 'Too long', 'warning');
		return;
	}

	if (!pnr.match(/^\d+$/))
	{
		setInputStatus('pnr', 'Non-standard personal number', 'warning');
		return;
	}
	
	var datePart = pnr.substring(0, pnrLen - 4); // Remove last four digits
	var dateFormat = pnrLen == 10 ? 'yyMMdd' : 'yyyyMMdd';
	var isValidDate = Dates.isDate(datePart, dateFormat);
	if (!isValidDate)
	{
		var dayInMonth = parseInt(datePart.substring(-2)); // Last two characters
		if (dayInMonth > 60)
		{
			// 'Samordningsnummer' has day-in-month + 60; check this
			dayInMonth -= 60;
			var tmpPnr = pnr.substring(0, pnrLen - 6); // First 4 or 6 digits is year+month
			if (dayInMonth < 10) tmpPnr += '0';
			tmpPnr += dayInMonth;
			isValidDate = Dates.isDate(tmpPnr, dateFormat);
		}
	}
	if (!isValidDate)
	{
		setInputStatus('pnr', 'Not a valid date', 'warning');
		return;
	}
	
	if (!personalNumberControlDigitCheck(pnr.substr(pnrLen == 10 ? 0 : 2)))
	{
		setInputStatus('pnr', 'Invalid control digit', 'warning');
		return;
	}
	
	setInputStatus('pnr', '', 'valid');
	pnrIsValid = true;
}

function samplingDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	samplingDateIsValid = false;
	setInputStatus('samplingDate', '', '');
	
	var samplingDate = frm.samplingDate.value;
	var samplingTime = frm.samplingTime.value;
	
	if (samplingDate != '' || samplingTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		samplingDate = autoFillDate(samplingDate);
		frm.samplingDate.value = samplingDate;

		samplingTime = autoFillTime(samplingTime);
		frm.samplingTime.value = samplingTime;
		
		if (!Dates.isDate(samplingDate, 'yyyyMMdd'))
		{
			setInputStatus('samplingDate', 'Not a valid date', 'invalid');
			return;
		}
		if (frm.freezerDate.value == '') frm.freezerDate.value = samplingDate;
		
		if (!Dates.isDate(samplingDate + ' ' + samplingTime, 'yyyyMMdd HHmm'))
		{
			if (samplingDate != '') setInputStatus('samplingDate', 'Not a valid time', 'invalid');
			return;
		}
		setInputStatus('samplingDate', '', 'valid');
	}
	samplingDateIsValid = true;
}

function freezerDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	freezerDateIsValid = false;
	setInputStatus('freezerDate', '', '');
	
	var freezerDate = frm.freezerDate.value;
	var freezerTime = frm.freezerTime.value;
	var freezerTimestamp;
	
	if (freezerDate != '' || freezerTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		freezerDate = autoFillDate(freezerDate);
		frm.freezerDate.value = freezerDate;

		freezerTime = autoFillTime(freezerTime);
		frm.freezerTime.value = freezerTime;
		
		if (!Dates.isDate(freezerDate, 'yyyyMMdd'))
		{
			setInputStatus('freezerDate', 'Not a valid date', 'invalid');
			return;
		}
		freezerTimestamp = Dates.parseString(freezerDate + ' ' + freezerTime, 'yyyyMMdd HHmm');
		if (freezerTimestamp == null)
		{
			if (freezerDate != '') setInputStatus('freezerDate', 'Not a valid time', 'invalid');
			return;
		}
		setInputStatus('freezerDate', '', 'valid');
	}
	
	freezerDateIsValid = true;

	if (samplingDateIsValid && freezerTimestamp)
	{
		var samplingTimestamp = Dates.parseString(frm.samplingDate.value + ' ' + frm.samplingTime.value, 'yyyyMMdd Hmm');
		if (samplingTimestamp && freezerTimestamp.getDate() != freezerTimestamp.getDate())
		{
			setInputStatus('freezerDate', 'Sampling and freezer dates are different', 'warning');
		}
	}
}

function getBloodInfo()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	var caseName = frm.caseName.value;
	var request = Ajax.getXmlHttpRequest();
	var url = 'BloodRegistration.servlet?ID=<%=ID%>&cmd=GetBloodInfo';
	url += '&caseName=' + caseName;
	request.open("GET", url, false); 
	request.send(null);
	
	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	// Get biosource information from the AJAX response
	bloodInfo = response.bloodInfo;
	patientInfo = response.patientInfo;
	consentInfo = response.consentInfo;
	
	if (patientInfo)
	{
		frm.personalNumber.value = patientInfo.personalNumber;
		gotoStep2();
	}
	
}

function gotoStep2()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	frm.caseName.disabled = true;
	frm.personalNumber.disabled = true;
	currentStep = 2;
	
	if (!patientInfo)
	{
		var pnr = frm.personalNumber.value;
		if (pnr.length == 10 && pnrIsValid) 
		{
			var year = fullYear(parseInt(pnr.substr(0, 2)));
			pnr = year + pnr.substr(2);
		}
		var request = Ajax.getXmlHttpRequest();
		var url = 'PersonalRegistration.servlet?ID=<%=ID%>&cmd=GetPatientInfo';
		url += '&personalNumber=' + pnr;
		url += '&pnrIsValid=' + pnrIsValid;
		request.open("GET", url, false); 
		request.send(null);
		
		if (debug) Main.debug(request.responseText);
		
		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		
		// Get patient information from the AJAX response
		patientInfo = response.patientInfo;
	}

	Main.show('gocancel');
	
	if (!patientInfo.id)
	{
		Main.show('newPatientSection');
		frm.patientCode.value=patientInfo.name;
		setInnerHTML('new.dateOfBirth', patientInfo.dateOfBirth ? patientInfo.dateOfBirth : "---");
		setInnerHTML('new.gender', patientInfo.gender ? patientInfo.gender : "---");
		frm.familyName.focus();
		if (!pnrIsValid)
		{
			setInputStatus('gender', 'Gender and DateOfBirth can\'t be automatically generated for non-standard Personal number', 'warning');
		}
	}
	else
	{
		Main.show('existingPatientSection');
		setInnerHTML('existing.patientCode', patientInfo.name);
		setInnerHTML('existing.familyName', patientInfo.familyName);
		setInnerHTML('existing.allFirstNames', patientInfo.allFirstNames);
		if (patientInfo.dateOfBirth) setInnerHTML('existing.dateOfBirth', patientInfo.dateOfBirth);
		if (patientInfo.gender) setInnerHTML('existing.gender', patientInfo.gender);
		gotoStep3();
	}
}

function gotoStep3()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	
	if (!patientInfo.id)
	{
		frm.patientCode.disabled = true;
		frm.familyName.disabled = true;
		frm.allFirstNames.disabled = true;
		patientInfo.familyName = frm.familyName.value;
		patientInfo.allFirstNames = frm.allFirstNames.value;
	}
	currentStep = 3;
	
	var updateMode = bloodInfo.id;
	Main.show('bloodSection');
	
	if (updateMode)
	{
		setInnerHTML('step3.title', 'Update blood \''+bloodInfo.name+'\'');
		if (bloodInfo.samplingDate != null)
		{
			frm.samplingDate.value = bloodInfo.samplingDate.substring(0, 8);
			frm.samplingTime.value = bloodInfo.samplingDate.substring(9, 13);
			samplingDateTimeOnChange();
		}
		if (bloodInfo.freezerDate != null)
		{
			frm.freezerDate.value = bloodInfo.freezerDate.substring(0, 8);
			frm.freezerTime.value = bloodInfo.freezerDate.substring(9, 13);
			freezerDateTimeOnChange();
		}
		frm.serum.checked = bloodInfo.serum == 'Yes';
		if (bloodInfo.bloodSample)
		{
			Forms.selectListOption(frm.bloodSample, bloodInfo.bloodSample);
		}
	}
	else
	{
		// Select 'PreNeo' if case name has 'C' suffix
		var caseName = frm.caseName.value;
		if (caseName.length > 7 && caseName.substring(7, 8) == 'C')
		{
			Forms.selectListOption(frm.bloodSample, 'PreNeo');
		}
		if (consentInfo && consentInfo.consent)
		{
			frm.copyConsent.value = consentInfo.id;
			var html = "From '" + consentInfo.name + "' (" + consentInfo.consent;
			if (consentInfo.consentDate) html += '; ' + consentInfo.consentDate;
			html += ')';
			setInnerHTML('copyConsent.text', html);	
			Main.show("copyConsentSection");
		}
	}
	
	Main.hide('gonext');
	if (updateMode)
	{
		Main.show('goupdate');
	}
	else
	{
		Main.show('gocreate');
	}
	
	frm.samplingDate.focus();
}

function goCreate()
{
	if (!step3IsValid()) return;
	
	Main.hide('gocreate');
	Main.hide('gocancel');
	Main.hide('goupdate');
	var frm = document.forms['reggie'];

	bloodInfo.samplingDate = Main.trimString(frm.samplingDate.value + ' ' + frm.samplingTime.value);
	bloodInfo.freezerDate = Main.trimString(frm.freezerDate.value + ' ' + frm.freezerTime.value);
	bloodInfo.serum = frm.serum.checked ? "Yes" : "No";
	bloodInfo.bloodSample = frm.bloodSample[frm.bloodSample.selectedIndex].value;
	if (frm.copyConsent.checked && frm.copyConsent.value)
	{
		bloodInfo.copyConsent = parseInt(frm.copyConsent.value);
	}

	frm.samplingDate.disabled = true;
	frm.samplingTime.disabled = true;
	frm.freezerDate.disabled = true;
	frm.freezerTime.disabled = true;
	frm.bloodSample.disabled = true;

	var updateMode = bloodInfo.id;
	var submitInfo = new Object();
	submitInfo.patientInfo = patientInfo;
	submitInfo.bloodInfo = bloodInfo;

	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	var url = 'BloodRegistration.servlet?ID=<%=ID%>&cmd=';
	url += updateMode ? 'UpdateBlood' : 'CreateBlood';
	request.open("POST", url, false);
	request.setRequestHeader("Content-Type", "application/json");
	request.send(JSON.stringify(submitInfo));

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');

}
</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Blood referral form registration" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Case + Personal number -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Enter Case Name and Personal Number</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Case name</td>
				<td class="input"><input type="text" name="caseName" 
					size="18" maxlength="12" onblur="caseNameOnChange()" onkeypress="focusOnEnter(event, 'personalNumber')"></td>
				<td class="status" id="case.status"></td>
				<td class="help"><span id="case.message" class="message" style="display: none;"></span>The case (barcode) associated with this patient.</td>
			</tr>
			<tr>
				<td class="prompt">Personal number</td>
				<td class="input"><input type="text" name="personalNumber" 
					size="18" maxlength="12" onkeyup="personalNumberOnChange()" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="pnr.status"></td>
				<td class="help"><span id="pnr.message" class="message" style="display: none;"></span>([YY]YYMMDDZZZZ)</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>

	<!-- 2. New patient registration -->
	<div id="newPatientSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle">New patient: Enter all names</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Patient code</td>
				<td class="input"><input type="text" name="patientCode" 
					value="" size="18" maxlength="12" 
					onkeypress="focusOnEnter(event, 'familyName')"></td>
				<td class="status" id="patientCode.status"></td>
				<td class="help"><span id="patientCode.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Family name</td>
				<td class="input"><input type="text" name="familyName" 
					value="" size="35" maxlength="255"
					onkeypress="focusOnEnter(event, 'allFirstNames')"></td>
				<td class="status" id="familyName.status"></td>
				<td class="help"><span id="familyName.message" class="message" style="display: none;"></span>Keep hyphens, keep åäö, replace all special accented letters [e.g. éèü etc] with standard alphabet character.</td>
			</tr>
			<tr valign="top">
				<td class="prompt">All first names</td>
				<td class="input"><input type="text" name="allFirstNames" 
					size="35" maxlength="255" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="allFirstNames.status"></td>
				<td class="help"><span id="allFirstNames.message" class="message" style="display: none;"></span>Type all names, see FamilyName comment on valid characters.</td>
			</tr>
			<tr>
				<td class="prompt">Gender</td>
				<td class="input" id="new.gender"></td>
				<td class="status" id="gender.status" rowspan="2"></td>
				<td class="help" rowspan="2"><span id="gender.message" class="message" style="display:none;"></span></td>
			</tr>
			<tr>
				<td class="prompt">Date of birth</td>
				<td class="input" id="new.dateOfBirth"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<!-- 2b. Existing patient -->
	<div id="existingPatientSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle">Existing patient: Verify names</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Patient code</td>
				<td class="input" id="existing.patientCode"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Family name</td>
				<td class="input" id="existing.familyName"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">All first names</td>
				<td class="input" id="existing.allFirstNames"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Gender</td>
				<td class="input" id="existing.gender"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Date of birth</td>
				<td class="input" id="existing.dateOfBirth"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>


	<!-- 3. Blood registration -->
	<div id="bloodSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">3</td>
		<td class="steptitle" id="step3.title">Create new blood</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr id="samplingDateSection" valign="top">
				<td class="subprompt">Blood sampling date</td>
				<td class="input"><input type="text" name="samplingDate" value="" size="12" maxlength="10" 
						onkeypress="focusOnEnter(event, 'samplingTime')" onblur="samplingDateTimeOnChange()">
					Time <input type="text" name="samplingTime" value="" size="6" maxlength="5" 
						onkeypress="focusOnEnter(event, 'freezerDate')" onblur="samplingDateTimeOnChange()"></td>
				<td class="status" id="samplingDate.status"></td>
				<td class="help"><span id="samplingDate.message" class="message" style="display: none;"></span>Date+time of blood sampling (YYYYMMDD, HHMM)</td>
			</tr>
			<tr id="freezerDateSection" valign="top">
				<td class="subprompt">Freezer date</td>
				<td class="input"><input type="text" name="freezerDate" value="" size="12" maxlength="10"
						onkeypress="focusOnEnter(event, 'freezerTime')" onblur="freezerDateTimeOnChange()">
					Time <input type="text" name="freezerTime" value="" size="6" maxlength="5"
						onblur="freezerDateTimeOnChange()"></td>
				<td class="status" id="freezerDate.status"></td>
				<td class="help"><span id="freezerDate.message" class="message" style="display: none;"></span>Date+time when put in freezer (YYYYMMDD, HHMM)</td>
			</tr>
			<tr id="serumSection" valign="top">
				<td class="subprompt">Plasma/serum</td>
				<td class="input">
					<input type="checkbox" name="serum" id="serum" value="1"><label for="serum">Yes</label>
				<td class="status" id="serum.status"></td>
				<td class="help">Mark the check box if serum/plasma is available.</td>
			</tr>
			<tr>
				<td class="prompt" id="bloodSample.prompt">Blood sample</td>
				<td class="input" id="bloodSample.input">
					<select name="bloodSample">
						<option selected value="">unknown
						<option value="PreNeo">PreNeo
						<option value="PreOp">PreOp
					</select>
				</td>
				<td class="status" id="bloodSample.status"></td>
				<td class="help"><span id="bloodSample.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr id="copyConsentSection" style="display: none;">
				<td class="prompt">Copy consent?</td>
				<td class="input">
					<input type="checkbox" name="copyConsent" id="copyConsent" value="" checked>
					<label for="copyConsent"><span id="copyConsent.text"></span></label>
				</td>
				<td class="status" id="copyConsent.status"></td>
				<td class="help"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
		<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
		<td><base:button id="goupdate" title="Update" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
		<td id="gonext.message" class="message"></td>
	</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>